Bug 1984609 (CVE-2021-36978)

Summary: CVE-2021-36978 qpdf: heap-based buffer overflow in Pl_ASCII85Decoder::write() when a certain downstream write fails
Product: [Other] Security Response Reporter: Guilherme de Almeida Suckevicz <gsuckevi>
Component: vulnerabilityAssignee: Nobody <nobody>
Status: NEW --- QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: twaugh, zdohnal
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: qpdf 10.1.0 Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2021-07-22 12:05:57 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On: 1984610, 1986720, 1986721    
Bug Blocks: 1984611    

Description Guilherme de Almeida Suckevicz 2021-07-21 18:35:33 UTC
QPDF 9.x through 9.1.1 and 10.x through 10.0.4 has a heap-based buffer overflow in Pl_ASCII85Decoder::write (called from Pl_AES_PDF::flush and Pl_AES_PDF::finish) when a certain downstream write fails.

Reference:
https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=28262

Upstream patch:
https://github.com/qpdf/qpdf/commit/dc92574c10f3e2516ec6445b88c5d584f40df4e5

Comment 1 Guilherme de Almeida Suckevicz 2021-07-21 18:35:50 UTC
Created qpdf tracking bugs for this issue:

Affects: fedora-all [bug 1984610]

Comment 2 Zdenek Dohnal 2021-07-22 12:05:57 UTC
Fixed in 10.1.0 and later, already covered by Fedora's qpdf.

Comment 3 Zdenek Dohnal 2021-07-22 12:16:06 UTC
Sorry, the bad bug.